///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CLocks_H
#define _CLocks_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define EXCLUSIVE_LOCK -0xFFFF //65,535

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CLocks{

private:
    CRITICAL_SECTION CS;
    int iRegularLockCount;
    int iExclusiveLockCount;

public:
	~CLocks(void);
	CLocks(void);

	__int64 UnLock(__int64 i64Value);
	unsigned __int64 UnLock(unsigned __int64 i64Value);

	bool UnLock(bool bValue);
	bool UnLockExclusive(bool bValue);

	char *UnLock(char *sValue);
	char *UnLockExclusive(char *sValue);

	double UnLock(double bValue);

	int Locks(void);
	int ExclusiveLocks(void);
	int RegularLocks(void);

	int UnLock(int iValue);
	int UnLockExclusive(int iValue);
	unsigned int UnLock(unsigned int iValue);

	void Lock(void);
	void LockExclusive(void);
	void UnLock(void);
	void UnLockExclusive(void);
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
